#!/usr/bin/env node
var e=require("path")
var r=require("fs")
var t=require("repl")
var s=require("../library/common/format")
var a=require("../library/common/string")
var o=require("../library/common/time")
var i=require("../library/common/check")
var n=require("../library/node/data/Stream")
var c=require("../library/node/file/File")
var u=require("../library/node/file/Modify")
var l=require("../library/node/server/function")
var p=require("../library/node/server/TCPProxyServer")
var m=require("../library/node/system/DefaultOpen")
var d=require("../library/node/system/Run")
var y=require("../library/node/system/ProcessStatus")
var f=require("../library/node/system/Status")
var v=require("./server/serveStatic")
var S=require("./server/websocketGroup")
var g=require("./server/testConnection")
var w=require("./function")
var b=require("./option")
const h=e=>console.log((0,i.isBasicObject)(e)?JSON.stringify(e,null,2):e)
const $=async(b,$)=>{const{tryGet:q,tryGetFirst:T,getFirst:O}=$
const A=q("quiet")?()=>{}:console.log
const N=(e,r)=>e(r).then(()=>A(`[${b}] done: ${r}`),e=>A(`[${b}] error: ${r}\n${e.stack||e}`))
const P=q(b)||[]
const k=Boolean(q("json"))
const x=T("input-file")
const F=T("output-file")
const j=async()=>{const e=(T("host")||"").split(":")
const r=e[0]||"0.0.0.0"
return{hostname:r,port:Number(e[1]||await(0,l.autoTestServerPort)([80,8080,8888,8800,8e3],r))}}
switch(b){case"eval":case"eval-readline":{let t=await(0,w.evalScript)(x?String((0,r.readFileSync)(x)):P[0],x?P:P.slice(1),x?(0,e.dirname)(x):process.cwd(),$)
"eval-readline"===b&&(t=await(0,w.evalReadlineExtend)(t,O("root"),A))
return void 0!==t&&(e=>F?(0,r.writeFileSync)(F,e):(0,n.pipeStreamAsync)(process.stdout,(0,n.bufferToStream)(e)))(t instanceof Buffer?t:Buffer.from(String(t)))}case"repl":return(0,t.start)({prompt:"> ",input:process.stdin,output:process.stdout,useGlobal:!0}).context.require=require
case"wait":{const e=P[0]||2e3
return(0,o.setTimeoutAsync)(e)}case"echo":return h(P)
case"cat":if(P.length)for(const e of P)await(0,n.pipeStreamAsync)(process.stdout,(0,r.createReadStream)(e))
else process.stdin.isTTY||await(0,n.pipeStreamAsync)(process.stdout,process.stdin)
return
case"write":case"append":if(process.stdin.isTTY)throw new Error("unsupported TTY stdin")
const l="write"===b?"w":"a"
return(0,n.pipeStreamAsync)((0,r.createWriteStream)(P[0],{flags:l}),process.stdin)
case"open":{const r=P[0]||"."
return(0,d.runSync)({command:(0,m.getDefaultOpen)(),argList:[r.includes("://")?r:(0,e.normalize)(r)]})}case"status":return h(k?{system:(0,f.getSystemStatus)(),process:(0,f.getCurrentProcessStatus)()}:(0,f.describeSystemStatus)())
case"file-list":case"file-list-all":case"file-tree":return h(await(0,w.collectFile)(b,P[0]||process.cwd()))
case"file-create-directory":for(const e of P)await N(c.createDirectory,e)
return
case"file-modify-copy":return u.modify.copy(P[0],P[1])
case"file-modify-move":return u.modify.move(P[0],P[1])
case"file-modify-delete":for(const e of P)await N(u.modify.delete,e)
return
case"file-merge":{const[e,...t]=P
for(const s of t)await(0,n.pipeStreamAsync)((0,r.createWriteStream)(e,{flags:"a"}),(0,r.createReadStream)(s))
return}case"fetch":{let[e,t=4,a=0]=P
t=Number(t)||0
a=Number(a)||0
const o=await(0,w.fetchWithJump)(e,{headers:{accept:"*/*","user-agent":`${w.packageName}/${w.packageVersion}`},timeout:a},t,(e,r,o)=>A(`[fetch] url: ${e}, jump: ${r}/${t}, timeout: ${a?(0,s.time)(a):"none"}, cookie: ${o.length}`))
const i=Number(o.headers["content-length"])
A(`[fetch] get status: ${o.status}, fetch response content${i?` (${(0,s.binary)(i)}B)`:""}...`)
await(e=>(0,n.pipeStreamAsync)(F?(0,r.createWriteStream)(F):process.stdout,e))(o.stream())
return A("\n[fetch] done")}case"process-status":{const[e="pid--"]=P
return h(await(k?y.getAllProcessStatusAsync:y.describeAllProcessStatusAsync)(e))}case"json-format":{const[e=2]=P
const t=JSON.parse((0,r.readFileSync)(x))
const a=(0,s.prettyStringifyJSON)(t,e)
return(0,r.writeFileSync)(F||x,a)}case"server-serve-static":case"server-serve-static-simple":{const[e=3e5]=P
const r="server-serve-static-simple"===b
const t=T("root")||process.cwd()
return(0,v.startServerServeStatic)(Object.assign({isSimpleServe:r,expireTime:Number(e),staticRoot:t,log:A},await j()))}case"server-websocket-group":return(0,S.startServerWebSocketGroup)(Object.assign({log:A},await j()))
case"server-test-connection":return(0,g.startServerTestConnection)(Object.assign({log:A},await j()))
case"server-tcp-proxy":{let e
let r
if((0,i.isBasicFunction)(P[0])){e=[{hostname:"custom-hostname",port:"custom-port"}]
r=P[0]}else{e=P.map(e=>{const[r,t]=e.split(":")
return{hostname:r||"localhost",port:Number(t)}})
let t=0
r=r=>{t=(t+1)%e.length
const s=e[t]
A(`[CONNECT] ${r.remoteAddress}:${r.remotePort} => ${s.hostname}:${s.port}`)
return s}}const{option:t,start:s}=(0,p.createTCPProxyServer)(Object.assign({getTargetOption:r},await j()))
await s()
return A((0,a.indentList)("[TCPProxy]",[`pid: ${process.pid}`,`at: ${t.hostname}:${t.port}`,...e.map(e=>`proxy to: ${e.hostname}:${e.port}`)]))}}};(async()=>{const e=await(0,b.parseOption)()
const r=b.MODE_NAME_LIST.find(r=>e.tryGet(r))
if(!r)return h(e.tryGet("version")?(0,w.getVersion)():(0,b.formatUsage)(null,e.tryGet("help")?null:"simple"))
await $(r,e).catch(e=>{console.warn(`[Error] in mode: ${r}:`,e.stack||e)
process.exit(2)})})().catch(e=>{console.warn((0,b.formatUsage)(e.stack||e,"simple"))
process.exit(1)})
