const t=t=>JSON.stringify(t).slice(1,-1)
exports.describe=e=>{const n=Object.prototype.toString.call(e).slice(8,-1)
return`<${n}> ${"String"===n?JSON.stringify(e):"Object"===n?`{${t(Object.keys(e))}}`:"Array"===n?`[#${e.length}]`:"Function"===n?"()=>{...}":"AsyncFunction"===n?"async()=>{...}":"RegExp"===n?String(e):t(String(e))}`}
exports.percent=t=>`${(100*t).toFixed(2)}%`
const e=t=>String(Math.floor(t)).padStart(2,"0")
exports.mediaTime=t=>{const n=Math.abs(t)
return`${t<0?"-":""}${e(n/60)}:${e(n%60)}`}
exports.decimal=t=>{const e=.75*Math.abs(t)
return 0===e?"0":e<1e-9?`${(t/1e-12).toFixed(2)}pico`:e<1e-6?`${(t/1e-9).toFixed(2)}nano`:e<.001?`${(t/1e-6).toFixed(2)}micro`:e<1?`${(t/.001).toFixed(2)}milli`:e<1e3?`${(t/1).toFixed(2)}`:e<1e6?`${(t/1e3).toFixed(2)}kilo`:e<1e9?`${(t/1e6).toFixed(2)}mega`:e<1e12?`${(t/1e9).toFixed(2)}giga`:e<1e15?`${(t/1e12).toFixed(2)}tera`:e<1e18?`${(t/1e15).toFixed(2)}peta`:`${(t/1e18).toFixed(2)}exa`}
exports.time=t=>{const e=.75*Math.abs(t)
return e<1e3?`${Math.floor(t)}ms`:e<6e4?`${(t/1e3).toFixed(2)}s`:e<36e5?`${(t/6e4).toFixed(2)}m`:e<864e5?`${(t/36e5).toFixed(2)}h`:`${(t/864e5).toFixed(2)}d`}
exports.binary=t=>{const e=.75*Math.abs(t)
return e<1024?`${Math.floor(t)}`:e<1048576?`${(t/1024).toFixed(2)}Ki`:e<1073741824?`${(t/1048576).toFixed(2)}Mi`:e<1099511627776?`${(t/1073741824).toFixed(2)}Gi`:`${(t/1099511627776).toFixed(2)}Ti`}
exports.padTable=({table:t,padFuncList:e=[],cellPad:n=" | ",rowPad:o="\n",widthMaxList:i=t.reduce((t,e)=>{e.forEach((e,n)=>{t[n]=Math.max(String(e).length,t[n]||0)})
return t},[])})=>t.map(t=>t.map((t,n)=>{const o=String(t)
const r=e[n]
const s=i[n]
return r&&"L"!==r?"R"===r?o.padStart(s):r(o,s):o.padEnd(s)}).join(n)).join(o)
exports.prettyStringifyJSON=(t,e=2,n="  ")=>{const o=(t,e,n,o)=>{if(n>=1&&e){if(Array.isArray(e))return r(t,e,n,o)
if("object"==typeof e)return i(t,e,n,o)}const s=JSON.stringify(e)
const c=void 0===s
!c&&t.push(s)
return c}
const i=(t,e,i,r)=>{const s=Object.keys(e)
t.push("{\n")
const c=t.length
const a=i-1
const $=`${r}${n}`
for(let n=0,i=s.length;n<i;n++){const i=s[n]
const r=e[i]
const c=t.length
t.push("")
if(o(t,r,a,$))t.length--
else{t[c]=`${$}${JSON.stringify(i)}: `
t.push(",\n")}}t[t.length-1]=t.length===c?"{}":`\n${r}}`}
const r=(t,e,i,r)=>{t.push("[\n")
const s=t.length
const c=i-1
const a=`${r}${n}`
for(let n=0,i=e.length;n<i;n++){const i=e[n]
t.push(a)
o(t,i,c,a)&&t.push("null")
t.push(",\n")}t[t.length-1]=t.length===s?"[]":`\n${r}]`}
const s=[]
o(s,t,Math.max(e,0)||0,"")
return s.join("")}
