var t=require("./check")
var e=require("./format")
const o=(t,e,o)=>{throw new Error(`[verify|${t}]${e?` ${e};`:""} ${o||""}`)}
const r=(t,r)=>(i,s)=>r(i)||o(t,s,`get: ${(0,e.describe)(i)}`)
const i=r("String",t.isString)
exports.string=i
const s=r("Boolean",t.isBoolean)
exports.boolean=s
const n=r("Number",t.isNumber)
exports.number=n
const c=r("Integer",t.isInteger)
exports.integer=c
const a=r("ObjectAlike",t.isObjectAlike)
exports.objectAlike=a
const u=r("BasicObject",t.isBasicObject)
exports.basicObject=u
exports.objectKey=(e,r,i)=>(0,t.isObjectKey)(e,r)||o("ObjectKey",i,`expect to have key: ${r}`)
exports.objectContain=(r,i,s)=>(0,t.isObjectContain)(r,i)||o("ObjectContain",s,`expect to contain: ${(0,e.describe)(i)}`)
const l=r("Array",t.isBasicArray)
exports.basicArray=l
exports.arrayLength=(r,i,s)=>(0,t.isArrayLength)(r,i)||o("ArrayLength",s,`expect length: ${i}, get: ${(0,t.isBasicArray)(r)?r.length:(0,e.describe)(r)}`)
const y=r("Function",t.isBasicFunction)
exports.basicFunction=y
const p=r("PromiseAlike",t.isPromiseAlike)
exports.promiseAlike=p
exports.oneOf=(r,i,s)=>(0,t.isOneOf)(r,i)||o("OneOf",s,`expect one of: [${i}], get: ${(0,e.describe)(r)}`)
exports.doThrow=(e,r)=>(0,t.isFunctionThrow)(e)||o("DoThrow",r)
exports.doNotThrow=(e,r)=>(0,t.isFunctionThrow)(e)&&o("DoNotThrow",r)
exports.doThrowAsync=async(e,r)=>await(0,t.isFunctionThrowAsync)(e)||o("DoThrowAsync",r)
exports.doNotThrowAsync=async(e,r)=>await(0,t.isFunctionThrowAsync)(e)&&o("DoNotThrowAsync",r)
const x=(t,o)=>`\nactual: ${(0,e.describe)(t)}\nexpect: ${(0,e.describe)(o)}`
exports.strictEqual=(e,r,i)=>(0,t.isStrictEqual)(e,r)||o("StrictEqual",i,x(e,r))
exports.notStrictEqual=(e,r,i)=>(0,t.isStrictEqual)(e,r)&&o("NotStrictEqual",i,x(e,r))
exports.stringifyEqual=(e,r,i="should stringify equal")=>(0,t.isStringifyEqual)(e,r)||o("StringifyEqual",i,x(e,r))
exports.notStringifyEqual=(e,r,i="should not stringify equal")=>(0,t.isStringifyEqual)(e,r)&&o("NotStringifyEqual",i,x(e,r))
