var t=require("../../../common/string")
const e={name:"",nameENV:"",nameCONFIG:"",shortName:"",aliasNameList:[],optional:!1,argumentCount:"0",argumentLengthMin:0,argumentLengthMax:0,argumentListNormalize:t=>t,argumentListVerify:t=>{},description:"",extendFormatList:[]}
exports.createOptionParser=({formatList:e,prefixENV:r="",prefixCONFIG:i=""})=>{const u=new Map
const g=new Map
const h=new Map
const N=new Map
const f=new Set
const C=new Set
const E=(e,o,c)=>{const{name:p,shortName:l,aliasNameList:$,argumentCount:L}=e
e.nameENV=(0,t.joinSnakeCase)((0,t.splitKebabCase)(r?`${r}-${p}`:p))
e.nameCONFIG=(0,t.joinCamelCase)((0,t.splitKebabCase)(i?`${i}-${p}`:p))
e.optional=a(e.optional,c)
const[,d,x,O]=n.exec(L.toString())
e.argumentLengthMin=parseInt(d)
e.argumentLengthMax=x?O?parseInt(O):1/0:e.argumentLengthMin
u.has(p)&&m(`duplicate name '${p}'`,e,o,c)
u.set(p,e)
l&&g.has(l)&&m(`duplicate shortName '${l}'`,e,o,c)
l&&g.set(l,e)
{const t=$.find(t=>u.has(t))
t&&m(`duplicate aliasName '${t}'`,e,o,c)
$.forEach(t=>u.set(t,e))}h.set(e.nameENV,e)
N.set(e.nameCONFIG,e)
e.optional?e.optional!==s&&C.add({format:e,checkOptional:e.optional}):f.add(e)
e.extendFormatList.forEach((t,n)=>E(t,n,e))};(e=e.map((t,e)=>o(t,e,null))).forEach((t,e)=>E(t,e,null))
return{parseCLI:p(c(u,g)),parseENV:l(h),parseCONFIG:$(N),processOptionMap:L(f,C),formatUsage:(t,n=!1)=>V(t&&`Message:\n${b(t.toString())}`,`CLI Usage:\n${b(d(e))}`,!n&&`ENV Usage:\n${b(x(e))}`,!n&&`CONFIG Usage:\n${b(O(e))}`)}}
const n=/^(\d+)(-)?(\d+)?$/
const a=(t,e)=>{"function"!=typeof t&&(t=!!t&&s)
return e?(n,a,s)=>t&&t(n,a,s)||!a.has(e):t}
const s=()=>!0
const o=(t,a,s)=>{t=Object.assign({},e,{},t)
!r.test(t.name)&&m(`name '${t.name}'`,t,a,s)
t.shortName&&!i.test(t.shortName)&&m(`shortName '${t.shortName}'`,t,a,s)
{const e=t.aliasNameList.findIndex(t=>!r.test(t));-1!==e&&m(`aliasNameList #${e} '${t.aliasNameList[e]}'`,t,a,s)}{!n.test(t.argumentCount)&&m(`argumentCount '${t.argumentCount}'`,t,a,s)
const[,e,,o]=n.exec(t.argumentCount)
o&&parseInt(o)<parseInt(e)&&m(`argumentCount '${t.argumentCount}'`,t,a,s)}t.extendFormatList.length&&(t.extendFormatList=t.extendFormatList.map((e,n)=>o(e,n,t)))
return t}
const r=/^[A-Za-z][A-Za-z0-9-]*$/
const i=/^[A-Za-z]$/
const m=(t,e,n,a)=>{throw new Error(`[Format] ${f(e)} #${n}${a?` of ${f(a)}`:""} | ${t}`)}
const c=(t,e)=>n=>{const a=[]
const s=()=>a[a.length-1].argumentList
for(let o=0,r=n.length;o<r;o++){const r=n[o]
if(u.test(r)){const[,e,,n]=u.exec(r)
const o=t.get(e)
!o&&h(e,"invalid option")
a.push({format:o,argumentList:[]})
n&&s().push(n)}else if(g.test(r)){const[,t,,n]=g.exec(r)
t.split("").forEach(n=>{const s=e.get(n)
!s&&h(n,`from '${t}'`)
a.push({format:s,argumentList:[]})})
n&&s().push(n)}else{!a.length&&h(r,"no leading option found")
if("--"===r){s().push(...n.slice(o+1))
break}s().push(r)}}return a}
const u=/^--([A-Za-z][A-Za-z0-9-]*)(=(.*))?$/
const g=/^-([A-Za-z]+)(=(.*))?$/
const h=(t,e)=>{throw new Error(`[ParseArgv] unexpected '${t}', ${e}`)}
const p=t=>(e,n={})=>t(e).reduce((t,{format:e,argumentList:n})=>{t[e.name]?t[e.name].argumentList.push(...n):t[e.name]={format:e,argumentList:n,source:"CLI"}
return t},n)
const l=t=>(e,n={})=>{t.forEach((t,a)=>{let s=e[a]
if(s){try{s=JSON.parse(s)}catch(t){}n[t.name]={format:t,argumentList:Array.isArray(s)?s:[s],source:"ENV"}}})
return n}
const $=t=>(e,n={})=>{t.forEach((t,a)=>{const s=e[a]
s&&(n[t.name]={format:t,argumentList:Array.isArray(s)?s:[s],source:"CONFIG"})})
return n}
const L=(t,e)=>(n,a)=>{const s=new Set
Object.entries(n).forEach(([t,e])=>{const{format:n,argumentList:o}=e
n.argumentLengthMin>o.length&&N(`expect ${n.argumentLengthMin-o.length} more argument`,n)
n.argumentLengthMax<o.length&&N(`expect ${o.length-n.argumentLengthMax} less argument`,n)
e.argumentList=n.argumentListNormalize(o,a)
n.argumentListVerify(e.argumentList,a)
s.add(n)})
t.forEach(t=>!s.has(t)&&N("non-optional option",t))
e.forEach(({format:t,checkOptional:e})=>!e(n,s,t)&&!s.has(t)&&N("non-optional option",t))
return n}
const N=(t,e)=>{throw new Error(`[Process] ${f(e)} | ${t}`)}
const f=({name:t,shortName:e,aliasNameList:n})=>`${t}${n.length?`|${n.join("|")}`:""}${e?` [-${e}]`:""}`
const d=t=>w(t,C)
const C=t=>V(M(t,`--${t.name}${t.aliasNameList.length?` --${t.aliasNameList.join(" --")}`:""}`,t.shortName&&`-${t.shortName}`),t.description&&b(t.description,4),F(t.extendFormatList,C,2))
const x=t=>V('"',b(`#!/usr/bin/env bash\n${w(t,E)}`),'"')
const E=t=>V(`export ${t.nameENV}="${M(t)}"`,F(t.extendFormatList,E,0))
const O=t=>V("{",b(w(t,I)),"}")
const I=t=>V(`"${t.nameCONFIG}": [ "${M(t)}" ],`,F(t.extendFormatList,I,0))
const M=({optional:t,argumentLengthMin:e,argumentLengthMax:n},...a)=>[...a,t&&(t===s?"[OPTIONAL]":"[OPTIONAL-CHECK]"),(e||n)&&`[ARGUMENT=${A(e,n)}]`].filter(Boolean).join(" ")
const F=(t,e,n)=>t.length&&b(w(t,e),n)
const A=(t,e)=>`${t}${e===1/0?"+":e>t?`-${e}`:""}`
const w=(t,e)=>V(...t.map(e))
const V=(...t)=>t.filter(Boolean).join("\n")
const b=(e,n=2)=>n?(0,t.indentLine)(e," ".repeat(n)):e
