exports.fromEmpty=()=>({left:1/0,right:-1/0,top:1/0,bottom:-1/0})
exports.fromPoint=(t,o)=>({left:Math.min(t.x,o.x),right:Math.max(t.x,o.x),top:Math.min(t.y,o.y),bottom:Math.max(t.y,o.y)})
exports.fromWidget=({center:t,size:o,rotate:a})=>{const e=Math.cos(a)
const h=Math.sin(a)
const r=.5*(Math.abs(o.x*e)+Math.abs(o.y*h))
const s=.5*(Math.abs(o.x*h)+Math.abs(o.y*e))
return{left:t.x-r,right:t.x+r,top:t.y-s,bottom:t.y+s}}
exports.fromWidgetList=t=>t.reduce((t,{center:o,size:a,rotate:e})=>{const h=Math.cos(e)
const r=Math.sin(e)
const s=.5*(Math.abs(a.x*h)+Math.abs(a.y*r))
const i=.5*(Math.abs(a.x*r)+Math.abs(a.y*h))
t.left=Math.min(t.left,o.x-s)
t.right=Math.max(t.right,o.x+s)
t.top=Math.min(t.top,o.y-i)
t.bottom=Math.max(t.bottom,o.y+i)
return t},{left:1/0,right:-1/0,top:1/0,bottom:-1/0})
exports.getCenter=({left:t,right:o,top:a,bottom:e})=>({x:.5*(t+o),y:.5*(a+e)})
exports.getUnion=(t,o)=>({left:Math.min(t.left,o.left),right:Math.max(t.right,o.right),top:Math.min(t.top,o.top),bottom:Math.max(t.bottom,o.bottom)})
exports.isIntersect=(t,o)=>!(t.left>o.right||t.right<o.left||t.top>o.bottom||t.bottom<o.top)
exports.isContainPoint=({left:t,right:o,top:a,bottom:e},{x:h,y:r})=>h>=t&&h<=o&&r>=a&&r<=e
