var t=require("../../math/base")
var e=require("./Vector")
const o=.5*Math.PI
exports.fromPoint=(t,e,o)=>Object.assign({},o,{center:{x:.5*(t.x+e.x),y:.5*(t.y+e.y)},size:{x:Math.abs(t.x-e.x),y:Math.abs(t.y-e.y)},rotate:0})
exports.fromLine=({begin:t,end:n},s,r)=>Object.assign({},r,{center:{x:.5*(t.x+n.x),y:.5*(t.y+n.y)},size:{x:s,y:(0,e.getDist)(n,t)},rotate:(0,e.getRotate)(n,t)-o})
exports.fromBoundingRect=({left:t,right:e,top:o,bottom:n},s)=>Object.assign({},s,{center:{x:.5*(t+e),y:.5*(o+n)},size:{x:e-t,y:n-o},rotate:0})
exports.getBoundingSize=({size:{x:t,y:e},rotate:o})=>{const n=Math.cos(o)
const s=Math.sin(o)
return{x:Math.abs(t*n)+Math.abs(e*s),y:Math.abs(t*s)+Math.abs(e*n)}}
const n=({size:{x:t,y:e},rotate:o})=>Math.abs(t*Math.cos(o))+Math.abs(e*Math.sin(o))
exports.getBoundingWidth=n
const s=({size:{x:t,y:e},rotate:o})=>Math.abs(t*Math.sin(o))+Math.abs(e*Math.cos(o))
exports.getBoundingHeight=s
exports.getBoundingLeft=t=>t.center.x-.5*n(t)
exports.getBoundingRight=t=>t.center.x+.5*n(t)
exports.getBoundingTop=t=>t.center.y-.5*s(t)
exports.getBoundingBottom=t=>t.center.y+.5*s(t)
exports.round=o=>Object.assign({},o,{center:(0,e.round)(o.center),size:(0,e.round)(o.size),rotate:(0,t.roundFloat)(o.rotate)})
exports.localPoint=({center:t,rotate:e},{x:o,y:n})=>{const s=o-t.x
const r=n-t.y
const a=Math.cos(-e)
const i=Math.sin(-e)
return{x:s*a-r*i,y:s*i+r*a}}
exports.localBoundingRect=({center:t,rotate:e},o)=>{const n=o.center.x-t.x
const s=o.center.y-t.y
const r=o.rotate-e
const a=Math.cos(r)
const i=Math.sin(r)
const c=n*a-s*i
const x=n*i+s*a
const y=.5*(o.size.x*a-o.size.y*i)
const g=.5*(o.size.x*i+o.size.y*a)
return{left:c-y,right:c+y,top:x-g,bottom:x+g}}
exports.isContainBoundingRect=({center:t,size:e},o)=>t.x-.5*e.x<=o.left&&t.x+.5*e.x>=o.right&&t.y-.5*e.y<=o.top&&t.y+.5*e.y>=o.bottom
exports.isInterceptBoundingRect=({center:t,size:e},o)=>!(t.x+.5*e.x<o.left||t.x-.5*e.x>o.right||t.y+.5*e.y<o.top||t.y-.5*e.y>o.bottom)
