var e=require("os")
var t=require("../../common/format")
var s=require("../../common/string")
var r=require("../../common/error")
const o=()=>({platform:(0,e.platform)(),arch:(0,e.arch)(),release:(0,e.release)()})
exports.getSystemPlatform=o
const i=({platform:e,arch:t,release:s}=o())=>`${e} ${t} [${s}]`
exports.describeSystemPlatform=i
const a=()=>(0,e.cpus)()||[{model:"N/A",speed:"N/A",times:{user:0,nice:0,sys:0,idle:0,irq:0}}]
exports.getSystemProcessor=a
const c=(e=a())=>e.map(({model:e,speed:s,times:r})=>`[${e}] speed:${s}MHz ${Object.entries(r).map(([e,s])=>`${e}:${(0,t.time)(s)}`).join(" ")}`).join("\n")
exports.describeSystemProcessor=c
const n=()=>({total:(0,e.totalmem)(),free:(0,e.freemem)()})
exports.getSystemMemory=n
const m=({total:e,free:s}=n())=>[`Used: ${(0,t.percent)((e-s)/e)}`,`Total: ${(0,t.binary)(e)}B`,`Free: ${(0,t.binary)(s)}B`].join("\n")
exports.describeSystemMemory=m
const p=()=>({hostname:(0,e.hostname)(),networkInterface:(0,e.networkInterfaces)()})
exports.getSystemNetwork=p
const d=({hostname:e,networkInterface:t}=p())=>[`[hostname] ${e}`,...Object.entries(t).map(([e,t])=>(0,s.indentList)(`[interface] ${e}`,t.map(({address:e,netmask:t,mac:s,internal:r,family:o,cidr:i})=>`[${o}${r?"|INTERNAL":""}] ${i||e} (${s})`)))].join("\n")
exports.describeSystemNetwork=d
const l=()=>({uptime:1e3*(0,e.uptime)(),loadAverageList:(0,e.loadavg)()})
exports.getSystemActivity=l
const y=({uptime:s,loadAverageList:r}=l())=>[`[uptime] ${(0,t.time)(s)}`,"win32"!==(0,e.platform)()&&`[load average] ${r.map(t.percent).join(", ")} (1min, 5min, 15min)`].filter(Boolean).join("\n")
exports.describeSystemActivity=y
const g=()=>({platform:o(),processor:a(),memory:n(),network:p(),activity:l()})
exports.getSystemStatus=g
exports.describeSystemStatus=({platform:e,processor:t,memory:r,network:o,activity:a}=g())=>Object.entries({platform:i(e),processor:c(t),memory:m(r),network:d(o),activity:y(a)}).map(([e,t])=>`[${e}]\n${(0,s.indentLine)(t)}`).join("\n")
exports.getCurrentProcessStatus=()=>({title:process.title,pid:process.pid,ppid:process.ppid,uid:(0,r.tryCall)(process,"getuid"),gid:(0,r.tryCall)(process,"getgid"),groups:(0,r.tryCall)(process,"getgroups")||[],euid:(0,r.tryCall)(process,"geteuid"),egid:(0,r.tryCall)(process,"getegid"),stdio:{stdin:u("stdin"),stdout:u("stdout"),stderr:u("stderr")},isConnectedIPC:Boolean(process.connected),execPath:process.execPath,execArgv:process.execArgv,argv:process.argv,cwd:process.cwd(),uptime:1e3*process.uptime(),cpuUsage:process.cpuUsage(),memoryUsage:process.memoryUsage()})
const u=e=>({isTTY:Boolean(process[e].isTTY)})
