const getSample = (func, size) => {
  const result = [];
  for (let index = 0; index < size; index++) result.push(func(index));
  return result;
};
const getSampleRange = (from, to) => getSample(index => index + from, to - from + 1);
const getSampleRate = divide => getSample(index => index / divide, 1 + divide);
export { getSample, getSampleRange, getSampleRate };