const getGlobal = () => "undefined" != typeof window ? window : "undefined" != typeof global ? global : this;
const getEnvironment = () => {
  const {process, window, document} = getGlobal();
  const isNode = void 0 !== process && void 0 !== process.versions && process.versions.node;
  const isBrowser = void 0 !== window && void 0 !== document;
  return {
    isNode,
    isBrowser,
    environmentName: isNode ? "node" : isBrowser ? "browser" : "unknown"
  };
};
const GLOBAL = getGlobal();
export { getGlobal, getEnvironment, GLOBAL as global };