import { networkInterfaces } from "os";
const getNetworkIPv4AddressList = () => Object.entries(networkInterfaces()).reduce((o, [interfaceName, interfaceList]) => {
  interfaceList.forEach(v => {
    "IPv4" === v.family && !1 === v.internal && o.push({
      ...v,
      interfaceName
    });
  });
  return o;
}, []);
export { getNetworkIPv4AddressList };